"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var os_1 = require("os");
var path_1 = require("path");
var rxjs_1 = require("rxjs");
var uuid_1 = require("uuid");
var copy_build_command_1 = require("../src/commands/copy.build.command");
var rx_delete_1 = require("../src/utils/rx.delete");
var factory_1 = require("./../src/commands/factory");
var rx_copy_1 = require("./../src/utils/rx.copy");
var test_utils_1 = require("./utils/test.utils");
var Browser = undefined;
describe('copy.build', function () {
    it('should be able to copy the resources', function () {
        var dir = os_1.tmpdir();
        var name = uuid_1.v4();
        var dstBase = path_1.join(dir, name);
        // copy a sample app
        var assetBase = test_utils_1.getAssetBaseDir();
        var srcSrc = path_1.join(assetBase, 'test', 'empty-project');
        var srcData = path_1.join(assetBase, 'test', 'oslo');
        var srcDist = path_1.join(assetBase, 'test', 'dist');
        var dstSrc = dstBase;
        var dstData = path_1.join(dstBase, 'data');
        var dstDist = path_1.join(dstBase, 'dist');
        var rxDelete = rx_delete_1.rxDeleteDir(dstBase);
        var rxCopySrc = rx_copy_1.rxCopyDir(srcSrc, dstSrc);
        var rxCopyData = rx_copy_1.rxCopyDir(srcData, dstData);
        var rxCopyDist = rx_copy_1.rxCopyDir(srcDist, dstDist);
        var rxCopy = rxjs_1.merge(rxCopySrc, rxCopyData, rxCopyDist);
        var appName = 'myApp';
        var fct = new factory_1.CommandFactory();
        var opt = {
            'command': copy_build_command_1.CopyBuildCommand.COMMAND,
            'commandType': copy_build_command_1.CopyBuildCommand.TYPE,
            'root': '/',
            'data': dstData,
            'src': dstDist,
            'name': appName,
            'allArgs': []
        };
        var cmd = fct.create(opt);
        var rxCmd = cmd.process();
        var rxTotal = rxjs_1.concat(rxDelete, rxCopy, rxCmd, rxDelete);
        return rxTotal.toPromise();
    });
});
