"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_wchtools_command_1 = require("./../src/commands/abstract.wchtools.command");
var constants_1 = require("../src/constants");
var lodash_1 = require("lodash");
var wchtools_1 = require("./../src/utils/wchtools");
describe('wchtools', function () {
    it('should ensure a trailing slash', function () {
        expect(wchtools_1.ensureTrailingSlash('http://www.example.org/test')).toEqual('http://www.example.org/test/');
        expect(wchtools_1.ensureTrailingSlash('http://www.example.org/test/')).toEqual('http://www.example.org/test/');
    });
    it('should fix argument list 1', function () {
        // arguments:
        var args = ['push', "--" + constants_1.OPTION_SOURCE, 'src', "--" + constants_1.OPTION_DATA, 'data'];
        var fixed = abstract_wchtools_command_1.wchtoolsFixArguments(args);
        expect(fixed).toBeDefined();
        expect(fixed.length).toEqual(1);
        expect(lodash_1.isEqual(fixed, ['push'])).toBeTruthy();
    });
    it('should fix argument list 2', function () {
        // arguments:
        var args = ["--" + constants_1.OPTION_SOURCE, 'src', "--" + constants_1.OPTION_DATA, 'data', 'pull', "--" + constants_1.OPTION_VERBOSE, '-lm'];
        var fixed = abstract_wchtools_command_1.wchtoolsFixArguments(args);
        expect(fixed).toBeDefined();
        expect(fixed.length).toEqual(2);
        expect(lodash_1.isEqual(fixed, ['pull', '-lm'])).toBeTruthy();
    });
});
