"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var create_layout_command_1 = require("./create.layout.command");
var empty_1 = require("./empty");
var create_react_command_1 = require("./create.react.command");
var create_vue_command_1 = require("./create.vue.command");
function _register(aCommand, aType, aConstructor, aMap) {
    // types
    var byType = aMap[aCommand] || (aMap[aCommand] = {});
    byType[aType] = aConstructor;
}
var CommandFactory = /** @class */ (function () {
    function CommandFactory() {
        this.commands = {};
        var cmd = this.commands;
        _register(create_react_command_1.CreateReactCommand.COMMAND, create_react_command_1.CreateReactCommand.TYPE, create_react_command_1.CreateReactCommand, cmd);
        _register(create_vue_command_1.CreateVueCommand.COMMAND, create_vue_command_1.CreateVueCommand.TYPE, create_vue_command_1.CreateVueCommand, cmd);
        // for eric's testing workflow
        _register(create_layout_command_1.CreateLayoutCommand.COMMAND, create_layout_command_1.CreateLayoutCommand.TYPE, create_layout_command_1.CreateLayoutCommand, cmd);
    }
    CommandFactory.prototype.create = function (options) {
        // get the type
        var cmd = options.command || 'help';
        var type = options.commandType || 'help';
        // lookup
        var byType = this.commands[cmd] || {};
        var creator = byType[type] || empty_1.EmptyCommand;
        // construct the command
        return new creator(options);
    };
    return CommandFactory;
}());
exports.CommandFactory = CommandFactory;
