"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var operators_1 = require("rxjs/operators");
var constants_1 = require("./../constants");
var wchtools_1 = require("./../utils/wchtools");
var abstract_command_1 = require("./abstract.command");
var help_1 = require("./help");
/* Copyright IBM Corp. 2017 */
function _logCredentials(aCredentials, aLogger) {
    // log the credentials
    var logCred = Object.assign({}, aCredentials);
    delete logCred.password;
    // log
    aLogger.next("Credentials " + JSON.stringify(logCred));
}
var StoreCredentialsCommand = /** @class */ (function (_super) {
    __extends(StoreCredentialsCommand, _super);
    function StoreCredentialsCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    StoreCredentialsCommand.prototype.printHelp = function () {
        // log the command line
        console.log(StoreCredentialsCommand.COMMAND, StoreCredentialsCommand.TYPE, "--" + constants_1.OPTION_URL + " <URL>", "--" + constants_1.OPTION_USER + " <USER>", "--" + constants_1.OPTION_PASSWORD + " <PASSWORD>");
        // log the parameters
        console.log("--" + constants_1.OPTION_URL, ':', help_1.HELP_API_URL);
        console.log("--" + constants_1.OPTION_USER, ':', help_1.HELP_USERNAME);
        console.log("--" + constants_1.OPTION_PASSWORD, ':', help_1.HELP_PASSWORD);
    };
    StoreCredentialsCommand.prototype.process = function () {
        // logger
        var logger = this.getLogger();
        // load the options
        return this.getWchToolsOptions().pipe(operators_1.tap(function (tools) { return _logCredentials(tools, logger); }), operators_1.mergeMap(wchtools_1.wchStoreCredentials));
    };
    StoreCredentialsCommand.TYPE = 'credentials';
    StoreCredentialsCommand.COMMAND = constants_1.CMD_STORE;
    return StoreCredentialsCommand;
}(abstract_command_1.AbstractCommand));
exports.StoreCredentialsCommand = StoreCredentialsCommand;
