"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function _visitNodes(aNodes, aEdges, aSet) {
    // iterate over all nodes
    if (aNodes && (aNodes.length > 0)) {
        // iterate
        aNodes.forEach(function (node) {
            // check if we know the node
            if (!aSet.has(node)) {
                // add the node
                aSet.add(node);
                // recurse
                _visitNodes(aEdges(node), aEdges, aSet);
            }
        });
    }
}
function connectedComponents(aNodes, aEdges) {
    // set of visited nodes
    var result = new Set();
    // recurse
    _visitNodes(aNodes, aEdges, result);
    // convert
    return Array.from(result.keys());
}
exports.connectedComponents = connectedComponents;
