"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* Copyright IBM Corp. 2017 */
var lodash_1 = require("lodash");
function isValidLayout(aLayout) {
    return aLayout && lodash_1.isString(aLayout.id) && lodash_1.isString(aLayout.name)
        && (aLayout.classification === 'layout') && (aLayout.templateType === 'angular');
}
exports.isValidLayout = isValidLayout;
function getLayoutsForTypes(aTypes, aTools) {
    // organize layout mappings per type
    var mappingPerType = new Map();
    lodash_1.forIn(aTools.layoutMappings, function (mapping) { return mappingPerType.set(mapping.type.id, mapping); });
    // generate the set
    var layouts = new Set();
    var result = lodash_1.flattenDeep(aTypes.map(function (type) { return mappingPerType.get(type.id); })
        .filter(Boolean)
        .map(function (mapping) { return mapping.mappings; })
        .filter(lodash_1.isArray)
        .map(function (mappings) { return mappings.map(function (mapping) { return mapping.layouts; }).filter(lodash_1.isArray).map(function (layouts) { return layouts.map(function (layout) { return layout.id; }).map(function (id) { return aTools.layouts[id]; }).filter(Boolean); }); }));
    // make this a set
    result.forEach(function (res) { return layouts.add(res); });
    return Array.from(layouts);
}
exports.getLayoutsForTypes = getLayoutsForTypes;
