const ngDeps = require('tools-angular-6-deps');
const pkg = require('./package.json');
const fs = require('fs');

function mergeDependencies(aDst, aSrc) {
    // merge in the source
    Object.keys(aSrc).forEach(name => {
        // check if we already have a dependency defined
        const oldDep = aDst[name];
        if (oldDep) {
            // check if we have a modifier
            let mod = (oldDep.length > 0) ? oldDep[0] : '';
            if ((mod !== '~') && (mod !== '^')) {
                mod = '^';
            }
            // update
            const newVersion = aDst[name] = `${mod}${aSrc[name]}`;
            // log
            if (newVersion !== oldDep) {
                console.log(`Rewriting [${name}] from [${oldDep}] to [${newVersion}].`)
            }
        }
    });
}

mergeDependencies(pkg.dependencies, ngDeps.dependencies);
mergeDependencies(pkg.devDependencies, ngDeps.dependencies);

fs.writeFileSync('./package.json', JSON.stringify(pkg, null, 2));