"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var constants_1 = require("./../constants");
var abstract_wchtools_command_1 = require("./abstract.wchtools.command");
var help_1 = require("./help");
/**
 * application push --data DATA_FOLDER
 */
var ApplicationPushCommand = /** @class */ (function (_super) {
    __extends(ApplicationPushCommand, _super);
    function ApplicationPushCommand(aOptions) {
        return _super.call(this, aOptions) || this;
    }
    ApplicationPushCommand.prototype.printHelp = function () {
        // log the command line
        console.log(ApplicationPushCommand.COMMAND, ApplicationPushCommand.TYPE, "--" + constants_1.OPTION_DATA + " <DATA>", "[--" + constants_1.OPTION_URL + " <URL>]", "[--" + constants_1.OPTION_USER + " <USER>]", "[--" + constants_1.OPTION_PASSWORD + " <PASSWORD>]", "[--" + constants_1.OPTION_AGGREGATED + "]", "[--" + constants_1.OPTION_OVERRIDE + "]", "[--" + constants_1.OPTION_VERBOSE + "]");
        // log the parameters
        console.log("--" + constants_1.OPTION_DATA, ':', help_1.HELP_DATA_DIRECTORY);
        console.log("--" + constants_1.OPTION_URL, ':', help_1.HELP_API_URL);
        console.log("--" + constants_1.OPTION_USER, ':', help_1.HELP_USERNAME);
        console.log("--" + constants_1.OPTION_PASSWORD, ':', help_1.HELP_PASSWORD);
        console.log("--" + constants_1.OPTION_OVERRIDE, ':', help_1.HELP_PROJECT_OVERRIDE);
        console.log("--" + constants_1.OPTION_AGGREGATED, ':', help_1.HELP_AGGREGATED);
        console.log("--" + constants_1.OPTION_VERBOSE, ':', help_1.HELP_VERBOSE);
    };
    ApplicationPushCommand.prototype.process = function () {
        // the options
        var opts = this.getOptions();
        // override?
        var bOverride = !!opts.override;
        // add the override commands if required
        var args = ['push', '-tlmwaicrCp'];
        if (bOverride) {
            args.push('-fI');
        }
        // dispatch
        return this.executeWchTools(args);
    };
    ApplicationPushCommand.TYPE = 'push';
    ApplicationPushCommand.COMMAND = constants_1.CMD_APP;
    return ApplicationPushCommand;
}(abstract_wchtools_command_1.AbstractWchToolsCommand));
exports.ApplicationPushCommand = ApplicationPushCommand;
