/* Copyright IBM Corp. 2017 */
import { Observable } from 'rxjs';

import { CMD_RUN } from './../constants';
import { Options } from './../options';
import { AbstractWchToolsCommand } from './abstract.wchtools.command';

export class RunWchToolsCommand extends AbstractWchToolsCommand {

    static readonly TYPE = 'wchtools';
    static readonly COMMAND = CMD_RUN;

    constructor(options: Options) {
        super(options);
    }

    process(): Observable<string> {
        // the arguments
        const opts = this.getOptions();
        const args = opts.allArgs.slice(2);
        // log this
        const logger = this.getLogger();
        logger.next(`Invoking wchtools [${JSON.stringify(args)}].`);
        // process
        return this.executeWchTools(args);
    }
}
