"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
var operators_1 = require("rxjs/operators");
var constants_1 = require("./../constants");
var config_1 = require("./../utils/config");
var wchtools_1 = require("./../utils/wchtools");
var abstract_command_1 = require("./abstract.command");
var help_1 = require("./help");
/* Copyright IBM Corp. 2017 */
var ShowUrlCommand = /** @class */ (function (_super) {
    __extends(ShowUrlCommand, _super);
    function ShowUrlCommand(options) {
        var _this = _super.call(this, options) || this;
        _this.options = options;
        return _this;
    }
    ShowUrlCommand.prototype.printHelp = function () {
        // log the command line
        console.log(ShowUrlCommand.COMMAND, ShowUrlCommand.TYPE, "--" + constants_1.OPTION_NAME + " <NAME>");
        // log the parameters
        console.log("--" + constants_1.OPTION_NAME + " <NAME>", ':', help_1.HELP_APPLICATION_NAME);
    };
    ShowUrlCommand.prototype.process = function () {
        // options
        var opts = this.options;
        // the directories
        var dataDirOpt = this.getDataDir();
        var appName = opts.name || this.getAppName();
        var contextRoot = "/" + config_1.configTrimSlashes(opts.root || this.getContextRoot(appName));
        return this.getWchToolsOptions().pipe(operators_1.mergeMap(function (toolsOpt) { return wchtools_1.wchGetIndexUrl(contextRoot, toolsOpt); }));
    };
    ShowUrlCommand.TYPE = 'url';
    ShowUrlCommand.COMMAND = constants_1.CMD_SHOW;
    return ShowUrlCommand;
}(abstract_command_1.AbstractCommand));
exports.ShowUrlCommand = ShowUrlCommand;
