import { AngularCliConfiguration } from './angular/angular';
import { assertNotNull } from './assert';

export function getDistDir(aConfig: AngularCliConfiguration): string {
    // get the default project
    const defaultProject = aConfig.defaultProject;
    // sanity check
    assertNotNull(defaultProject, 'defaultProject');
    // check the project
    const project = aConfig.projects![defaultProject!] as any;
    return project.architect.build.options.outputPath;
}

export function getSrcDir(aConfig: AngularCliConfiguration): string {
    // get the default project
    const defaultProject = aConfig.defaultProject;
    // sanity check
    assertNotNull(defaultProject, 'defaultProject');
    // check the project
    const project = aConfig.projects![defaultProject!] as any;
    return project.sourceRoot;
}