"use strict";
exports.__esModule = true;
var graceful_fs_1 = require("graceful-fs");
var Handlebars = require("handlebars");
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var jsStringEscape = require('js-string-escape');
var helpers = require('handlebars-helpers')({ handlebars: Handlebars });
// add custom helpers
Handlebars.registerHelper('jsEscape', jsStringEscape);
function _compile(aFile) {
    return rxjs_1.Observable.create(function (observer) {
        // read the file
        graceful_fs_1.readFile(aFile, 'utf-8', function (err, data) {
            if (err) {
                observer.error(err);
            }
            else {
                try {
                    observer.next(Handlebars.compile(data));
                    observer.complete();
                }
                catch (error) {
                    observer.error(error);
                }
            }
        });
    }).pipe(operators_1.shareReplay());
}
exports.hbsCompile = _compile;
